(*****************************************************************************)
(*                                                                           *)
(* Open Source License                                                       *)
(* Copyright (c) 2023 Functori --- <contact@functori.com>                    *)
(*                                                                           *)
(* Permission is hereby granted, free of charge, to any person obtaining a   *)
(* copy of this software and associated documentation files (the "Software"),*)
(* to deal in the Software without restriction, including without limitation *)
(* the rights to use, copy, modify, merge, publish, distribute, sublicense,  *)
(* and/or sell copies of the Software, and to permit persons to whom the     *)
(* Software is furnished to do so, subject to the following conditions:      *)
(*                                                                           *)
(* The above copyright notice and this permission notice shall be included   *)
(* in all copies or substantial portions of the Software.                    *)
(*                                                                           *)
(* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR*)
(* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,  *)
(* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL   *)
(* THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER*)
(* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING   *)
(* FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER       *)
(* DEALINGS IN THE SOFTWARE.                                                 *)
(*                                                                           *)
(*****************************************************************************)

(** This OCaml file provides a subcommand for renaming anonymous types generated
by a previous build of the interface for a smart contract. The subcommand takes
the name of the smart contract as an argument and renames the anonymous types in
the generated interface files. Warning: this short summary was automatically
generated and could be incomplete or misleading. If you feel this is the case,
please open an issue. *)

open Factori_command
open Factori_options
open Factori_errors
open Factori_utils

let ( // ) = concat

let rename_variables =
  subcommand ~name:"rename variables" ~args:[contract_name_anonymous]
    ~doc:
      "Rename some or all anonymous types (type0,type1,etc...) possibly \
       generated by the previous build of the interface. This will be \
       effective for all programming language interfaces (OCaml, Typescript, \
       future languages)" (fun () ->
      try
        let contract_name =
          match !contract_name with
          | None ->
            raise
              (GenericError
                 ( "rename_variables",
                   "No name provided for contract whose interface you want to \
                    build" ))
          | Some contract_name -> sanitize_basename contract_name in
        let dir = Factori_config.get_dir () in
        let typenaming_file =
          Factori_config.get_typenaming_file ~dir ~contract_name in
        let types =
          deserialize_file ~silent:false ~filename:typenaming_file
            ~enc:Infer_entrypoints.Naming.typenames_encoding in
        let remaining = List.map fst types in
        let rec aux res =
          let open Format in
          function
          | ([] : sanitized_name list) ->
            eprintf "Renaming finished.\n%!" ;
            res
          | name :: names -> (
            eprintf
              "Would you like to rename type %s corresponding to %a? (S for \
               Skip, E to end renaming, otherwise type new name)\n\
               %!"
              (show_sanitized_name name) Types.pp_type_
              (match List.assoc_opt name res with
              | None ->
                eprintf "couldn't find %s\n" (show_sanitized_name name) ;
                TVar (sanitized_of_str "<no such type found>", Base Unit)
              | Some t -> t) ;
            let s = Stdlib.read_line () in
            match s with
            | "s" | "S" -> aux res names
            | "e" | "E" ->
              eprintf "Renaming ended by user.\n%!" ;
              res
            | new_name ->
              let new_name = sanitized_of_str new_name in
              let new_res =
                List.map
                  (fun (n, t) ->
                    ( (if eq_sanitized n name then
                         new_name
                       else
                         n),
                      Infer_entrypoints.Naming.subst name new_name t ))
                  res in
              aux new_res names) in
        serialize_file ~filename:typenaming_file
          ~enc:Infer_entrypoints.Naming.typenames_encoding (aux types remaining) ;
        Format.eprintf "Successfully renamed variables.\n%!"
      with e -> handle_exception e)
